Description

Let me expose a lack of feature in Redmine regarding Repositories and Projects management.

From my point of view, Repository Mangement should be done at the Application Level (Redmine) and not at the Project level. Like

Projects I should manage my repositories (SVN, CVS, etc.) through the Administration Panel: Repositories | New.

Those Repositories would be eligible to be associated to a project through a "Repository Location" entity. A Repository Location

would be the association between a Repository and a specific path.

So, if I want to associate a Repository Location to a project, I click on Add Repository Location and I follow the wizard :

1. The user selects if he wants to create a new repository or reuse an existing one.

2. The user selects the repository to reuse and click on OK.

3. The user enters the path relative to the root of the repository (e.g. /, /<project-name>/trunk, /<root-name>/trunk/<project-name>,

/trunk/<project-name>)

4. The system checks that the path exists and associates the repository location to the project.

If the user wants to use dedicated repository

2 The user clicks on new repository, the user goes through the process to create a new repository and goes to the step 3.

If the path does not exist

4. The systems detects that the path does not exist and asks the user to enter a commit message.

5. The user enters a commit message and click on OK.

6. The system imports the path and associate the repository location to the project.

--

This new design could enable great flexiblity lettings us to:

Associate one or more Repository Location to a project, the underlying source control could be CVS, SVN and could be mixed

through a project.

The Repository Location could be either:

a dedicated repository for this project, or

a specific path of an existing repository.

Finally, those they want to associate a specific repository to a project and those they want to manage all their projects through a

single repository will be happy. Letting others to manange their projects via a mixed repository strategy depending of their needs.

Any thoughts will be appreciated?

Regards,

Alexandre

Related issues:

Related to Redmine - Feature #2214: Autocreate repositories New 2008-11-19

History
#1 - 2008-09-23 01:13 - Gerrit Kaiser

Alexandre Garino wrote:

The Repository Location could be either:

a dedicated repository for this project, or

a specific path of an existing repository.

 Using a path in an existing Repository will only work for SCMs similar to SVN. In Git, something like that is not possible afaik.

#2 - 2008-09-25 10:14 - Thomas Lecavelier

(copy from forum message)

It's an interesting and well considered request. Indeed, at after reading that, I think it make sens to push up Repositories in hierachy. Some problem

would appear:

links in r42 form will become a problem (how to translate them when no repo' linked? Or more than one? Need of a new syntax

new rights have to be added upon repositories: we have to know which can be related to other projects (shared) and which can't (it'd be a pity

that your latest killer-app could be view by your competitor if you're hosted on a shared redmine :)

I still have fear about server-side repo creation, with the potential of massive spam-bot attack: databases and filers don't like to be full :)

HTH

#3 - 2011-01-18 03:45 - Toshi MARUYAMA

- Category set to SCM

#4 - 2011-03-29 06:00 - Toshi MARUYAMA

- Category changed from SCM to SCM extra
